<?php

//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// $Id: parse_output.php,v 1.7 2002/04/19 18:12:41 bene1 Exp $
// File: parse_output.php
// Function: convert text output from ipacsum into html-table
//           

function parse_output($input, $in_rules, $out_rules) {
    global $text;
    $traffic = array();

    $input_ar = explode("\n",$input);

    while ($line = each($input_ar)) {
        if (eregi("Host: (.*) / Time created: (.*)$",$line[1], $regs)) {
	    $host = $regs[1];
	    $create_time = $regs[2];
	    continue;
	}
	if (eregi("Data from (.*) to (.*)$", $line[1], $regs)) {
	    $data_from = $regs[1];
	    $data_to = $regs[2];
	    continue;
	}
	if (eregi("^(\*)? ([a-zA-Z0-9_\. ]*):(.*)$",$line[1],$regs)) {
	    array_push($traffic, array("rule" => trim($regs[2]),
				     "traffic" => trim($regs[3]),
				     "status" => $regs[1]
				    ));
	    if ($regs[1] == "*") {
		$incomplete_msg = 1;
	    }
	}
    }
    $code = <<<EOD
<table border="0" width="100%">
<tr>
    <td align="center" width="50%">
	<table width="90%">
	<tr>
	    <td>{$text["hostname"]}</td>
	    <td >$host</td>
	</tr>
	<tr>
	    <td>{$text["create_time"]}</td>
	    <td>$create_time</td>
	</tr>
	<tr>
	    <td>{$text["start_time"]}</td>
	    <td>$data_from</td>
	</tr>
	<tr>
	    <td>{$text["end_time"]}</td>
	    <td>$data_to</td>
	</tr>
	</table>
    </td>
</tr>
<tr>
    <td> &nbsp;
    </td>
</tr>
<tr>
    <td align="center" width="50%" valign="top">
EOD;
    if (count($in_rules) !=  0) {
        $code .= printtable($traffic, $in_rules);
    } else {
	$code .= "<b>".$text["no_input_rules"]."</b>";
    }
    $code .= <<<EOD
    
    </td>
    <td align="center" width="50%" valign="top">
EOD;
    if (count($out_rules) != 0) {
        $code .= printtable($traffic, $out_rules);
    } else {
	$code .= "<b>".$text["no_output_rules"]."</b>";
    }
	
    $code .= <<<EOD

    </td>
</tr>
EOD;
    if ($incomplete_msg == 1) {
	$code .= <<<EOD
<tr>
    <td> &nbsp; </td>
</tr>
<tr> 
    <td width="50%">
	<table width="90%" border="0" align="center">
	<tr>
	    <td>* = {$text['data_incomplete']} </td>
	</tr>
	</table>
    </td>
</tr>
EOD;
    }
    $code .= <<<EOD
</table>
EOD;
    return $code;

}


function artrim(&$value, $key) {
    $value = trim($value);
}

function printtable ($traffic, $rules) {
    global $text;
    reset($rules);
    array_walk($rules, 'artrim');
    $return = <<<EOD

    	<table border="0" width="90%" style="border-collapse:collapse;">
	<tr>
	    <td style="text-align:left;border-bottom:1px solid black">{$text['rule']}</td>
	    <td style="text-align:right;border-bottom:1px solid black">{$text['traffic']}</td>
	</tr>  
EOD;
    while ($item = each($traffic)) {
	if (in_array($item[1]["rule"], $rules)) {
	    $return .= <<<EOD
	<tr>
	    <td>{$item[1]["status"]} {$item[1]["rule"]}
	    </td>
	    <td style="text-align:right">{$item[1]["traffic"]}
	    </td>
	</tr>
EOD;
	}
    }
    $return .= <<<EOD

    	</table>
EOD;
    return $return;
}


?>
